传送门
文章目录
- 题意:
- 思路:
题意:
思路:
找规律yydsyydsyyds。
一看没什么想法,所以打了个表,好家伙,不打不知道,一打不得了,下面是n=6n=6n=6的符合要求的情况:
不难发现,他符合条件的个数为2n−12^{n-1}2n−1个,并且很有规律,以某个数开头的个数分别为1,20,21,22,...,2n−21,2^0,2^1,2^2,...,2^{n-2}1,20,21,22,...,2n−2,并且加入这个数之后小于他的数也都跟在后面了,之后又是上面那种情况,类似于递归。
比如333开头的,我们通过不断k−=2xk-=2^xk−=2x最终确定在以333开头的块内,让后把3213 \ \ 2 \ \ 13 2 1放入答案,之后发现又在444的块内,让后将43214\ \ 3 \ \ 2 \ \ 14 3 2 1加入答案,由于3213 \ \ 2 \ \ 13 2 1之前加入了,所以加入444即可,一直这样递归确定块即可。
由于nnn很大,我们不能算出来2n2^n2n,所以让他等于一个大于kkk的数即可。
附赠打标程序。
// Problem: B. Almost Sorted
// Contest: Codeforces - Codeforces Round #715 (Div. 1)
// URL: https://codeforces.com/problemset/problem/1508/B
// Memory Limit: 256 MB
// Time Limit: 2000 ms
//
// Powered by CP Editor (https://cpeditor.org)//#pragma GCC optimize("Ofast,no-stack-protector,unroll-loops,fast-math")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4.1,sse4.2,avx,avx2,popcnt,tune=native")
//#pragma GCC optimize(2)
#include<cstdio>
#include<iostream>
#include<string>
#include<cstring>
#include<map>
#include<cmath>
#include<cctype>
#include<vector>
#include<set>
#include<queue>
#include<algorithm>
#include<sstream>
#include<ctime>
#include<cstdlib>
#define X first
#define Y second
#define L (u<<1)
#define R (u<<1|1)
#define pb push_back
#define mk make_pair
#define Mid (tr[u].l+tr[u].r>>1)
#define Len(u) (tr[u].r-tr[u].l+1)
#define random(a,b) ((a)+rand()%((b)-(a)+1))
#define db puts("---")
using namespace std;//void rd_cre() { freopen("d://dp//data.txt","w",stdout); srand(time(NULL)); }
//void rd_ac() { freopen("d://dp//data.txt","r",stdin); freopen("d://dp//AC.txt","w",stdout); }
//void rd_wa() { freopen("d://dp//data.txt","r",stdin); freopen("d://dp//WA.txt","w",stdout); }typedef long long LL;
typedef unsigned long long ULL;
typedef pair<int,int> PII;const int N=1000010,mod=1e9+7,INF=0x3f3f3f3f;
const double eps=1e-6;int n; LL k;
int a[N];
LL b[N],inf;
bool st[N];
vector<pair<LL,int>>v;
vector<int>ans;bool check() {for(int i=1;i<6;i++) if(a[i+1]<a[i]-1) return false;return true;
}LL qmi(LL a,LL b) {LL ans=1;while(b) {if(b&1) ans=ans*a;a=a*a;b>>=1;}return ans;
}void solve() {for(int i=1;i<=n;i++) {if(i==n) b[i]=1;else {int now=n-i-1;if(now>=62) b[i]=inf;else b[i]=qmi(2ll,now);}}for(int i=1;i<=n;i++) {if(k>b[i]) {k-=b[i];}else {for(int j=i;j>=1&&!st[j];j--) ans.pb(j),st[j]=1;}}for(auto x:ans) printf("%d ",x); puts("");
}int main()
{
// ios::sync_with_stdio(false);
// cin.tie(0);/*for(int i=1;i<=6;i++) a[i]=i;do {if(check()) {for(int i=1;i<=6;i++) printf("%d ",a[i]);puts("");}}while(next_permutation(a+1,a+1+6));*/inf=qmi(2ll,62);int _; scanf("%d",&_);while(_--) {scanf("%d%lld",&n,&k);ans.clear();for(int i=1;i<=n;i++) st[i]=0;if(n==1) {if(k!=1) puts("-1");else printf("1\n");continue;}if(n-2>=62) solve();else {LL now=qmi(2ll,n-1);if(k>now) puts("-1");else solve();}}return 0;
}
/**/